module StringMachete
  [:halves, :thirds, :fourths, :fifths, :sixths,
   :sevenths, :eigths, :nineths, :tenths].each_with_index do |m_name, index|
    define_method(m_name) do 
      return nil if self.length % (index+2) > 0

      interval = self.length / (index+2)
      e_interval = self.length % (index+2)
      intervals = Array.new(index+2) { |i| [i*interval, (i+1)*interval] }

      intervals.map do |i|
        self[i[0]...i[1]]
      end
    end
  end

  def /(divisor)
    interval = self.length / divisor
    e_interval = self.length % divisor
    intervals = Array.new(divisor) { |i| [i*interval, (i+1)*interval] }

    intervals.map do |i|
      self[i[0]...i[1]]
    end
  end

  def %(divisor)
    e_interval = self.length % divisor

    e_interval > 0 ? [self[-e_interval..-1]] : []
  end

  def divide_by divisor
    remainder = self % divisor
    (self / divisor) + (remainder.any? ? [remainder] : [])
  end
end

String.include StringMachete